// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Vg_memo.pas' rev: 21.00

#ifndef Vg_memoHPP
#define Vg_memoHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <Strutils.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Clipbrd.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Vg_scene.hpp>	// Pascal unit
#include <Vg_controls.hpp>	// Pascal unit
#include <Vg_layouts.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vg_memo
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TEditCharCase { vgecNormal, vgecUpperCase, vgecLowerCase };
#pragma option pop

#pragma option push -b-
enum TInsertOption { ioSelected, ioMoveCaret, ioCanUndo, ioUnDoPairedWithPriv };
#pragma option pop

typedef Set<TInsertOption, ioSelected, ioUnDoPairedWithPriv>  TInsertOptions;

#pragma option push -b-
enum TDeleteOption { doMoveCaret, doCanUndo };
#pragma option pop

typedef Set<TDeleteOption, doMoveCaret, doCanUndo>  TDeleteOptions;

#pragma option push -b-
enum TActionType { atDelete, atInsert };
#pragma option pop

typedef DynamicArray<int> TLinesBegs;

typedef TLinesBegs *PLinesBegs;

struct TCaretPosition
{
	
public:
	int Line;
	int Pos;
};


struct TEdtAction;
typedef TEdtAction *PEdtAction;

struct TEdtAction
{
	
public:
	TActionType ActionType;
	bool PairedWithPriv;
	int StartPosition;
	System::WideString DeletedFragment;
	int Length;
};


class DELPHICLASS TEdtActionStack;
class DELPHICLASS TvgMemo;
class PASCALIMPLEMENTATION TEdtActionStack : public Contnrs::TStack
{
	typedef Contnrs::TStack inherited;
	
private:
	TvgMemo* FOwner;
	
public:
	__fastcall TEdtActionStack(TvgMemo* AOwner);
	__fastcall virtual ~TEdtActionStack(void);
	void __fastcall FragmentInserted(int StartPos, int FragmentLength, bool IsPairedWithPriv);
	void __fastcall FragmentDeleted(int StartPos, System::WideString Fragment);
	void __fastcall CaretMovedBy(int Shift);
	bool __fastcall RollBackAction(void);
};


typedef DynamicArray<Vg_scene::TvgRect> TSelArea;

class PASCALIMPLEMENTATION TvgMemo : public Vg_layouts::TvgScrollBox
{
	typedef Vg_layouts::TvgScrollBox inherited;
	
private:
	typedef DynamicArray<int> _TvgMemo__1;
	
	typedef DynamicArray<int> _TvgMemo__2;
	
	
private:
	bool FNeedChange;
	System::WideString FText;
	Vg_scene::TvgBrush* FFontFill;
	Vg_scene::TvgFont* FFont;
	Vg_scene::TvgTextAlign FTextAlign;
	bool FInternalMustUpdateLines;
	bool FLMouseSelecting;
	Vg_scene::TvgPoint FOldMPt;
	TCaretPosition FCaretPosition;
	int FFirstVisibleChar;
	Vg_scene::TvgWideStrings* FUnwrapLines;
	Menus::TPopupMenu* FPopupMenu;
	bool FAutoSelect;
	TEditCharCase FCharCase;
	bool FHideSelection;
	int FMaxLength;
	bool FReadOnly;
	Classes::TNotifyEvent FOnChange;
	Classes::TAlignment FTextAlignment;
	TEdtActionStack* FActionStack;
	Vg_scene::TvgWideStrings* FLines;
	bool FWordWrap;
	_TvgMemo__1 FLinesBegs;
	TCaretPosition FSelStart;
	TCaretPosition FSelEnd;
	bool FSelected;
	int FOldSelStartPos;
	int FOldSelEndPos;
	int FOldCaretPos;
	Vg_scene::TvgBrush* FSelectionFill;
	Classes::TNotifyEvent FOnChangeTracking;
	TCaretPosition __fastcall GetSelBeg(void);
	TCaretPosition __fastcall GetSelEnd(void);
	void __fastcall StorePositions(void);
	void __fastcall RestorePositions(void);
	void __fastcall SelectAtPos(const TCaretPosition &APos);
	void __fastcall SetCaretPosition(const TCaretPosition &Value);
	void __fastcall SetSelLength(const int Value);
	void __fastcall SetSelStart(const int Value);
	int __fastcall GetSelStart(void);
	int __fastcall GetSelLength(void);
	void __fastcall UpdateHScrlBarByCaretPos(void);
	void __fastcall UpdateVScrlBarByCaretPos(void);
	System::WideString __fastcall GetSelText(void);
	void __fastcall SetAutoSelect(const bool Value);
	void __fastcall SetCharCase(const TEditCharCase Value);
	void __fastcall SetHideSelection(const bool Value);
	void __fastcall SetMaxLength(const int Value);
	void __fastcall SelectAtMousePoint(void);
	TCaretPosition __fastcall GetNextWordBeging(const TCaretPosition &StartPosition);
	TCaretPosition __fastcall GetPrivWordBeging(const TCaretPosition &StartPosition);
	TCaretPosition __fastcall GetPositionShift(const TCaretPosition &APos, int Delta);
	void __fastcall MoveCareteBy(int Delta);
	void __fastcall MoveCaretLeft(void);
	void __fastcall MoveCaretRight(void);
	void __fastcall MoveCaretVertical(int LineDelta);
	void __fastcall MoveCaretDown(void);
	void __fastcall MoveCaretUp(void);
	void __fastcall MoveCaretPageUp(void);
	void __fastcall MoveCaretPageDown(void);
	void __fastcall UpdateCaretPosition(bool UpdateScrllBars);
	void __fastcall SetTextAlignment(const Classes::TAlignment Value);
	void __fastcall SetLines(const Vg_scene::TvgWideStrings* Value);
	void __fastcall GetLineBounds(int LineIndex, int &LineBeg, int &LineLength);
	int __fastcall GetLineCount(void);
	System::WideString __fastcall GetLine(int Index);
	System::WideString __fastcall GetLineInternal(int Index);
	void __fastcall InsertLine(int Index, const System::WideString S);
	void __fastcall DeleteLine(int Index);
	void __fastcall ClearLines(void);
	void __fastcall SetWordWrap(const bool Value);
	float __fastcall GetPageSize(void);
	float __fastcall GetLineWidth(int LineNum);
	int __fastcall GetWidestLine(void);
	int __fastcall FillLocalLinesBegs(System::PWideString PText, int ABegChar, int AEndChar, PLinesBegs TmpLinesBegs);
	void __fastcall UpdateRngLinesBegs(System::PWideString PText, int AUpdBegLine, int AUpdEndLine, int AUpdBegChar, int AUpdEndChar, int ACharDelta, int AOldWideslLineWidth);
	bool __fastcall GetShowSelection(void);
	TCaretPosition __fastcall GetLineRealEnd(const TCaretPosition &AStartPos, System::PWideString PText);
	void __fastcall SetFont(const Vg_scene::TvgFont* Value);
	void __fastcall SetTextAlign(const Vg_scene::TvgTextAlign Value);
	float __fastcall TextWidth(const System::WideString Str);
	void __fastcall HScrlBarChange(System::TObject* Sender);
	void __fastcall SetUpdateState(bool Updating);
	Vg_scene::TvgWideStrings* __fastcall GetUnwrapLines(void);
	
protected:
	bool FUpdating;
	int FWidesLineIndex;
	_TvgMemo__2 FTextWidth;
	float __fastcall GetLineHeight(void);
	TCaretPosition __fastcall GetPointPosition(const Vg_scene::TvgPoint &Pt);
	virtual void __fastcall SetText(const System::WideString Value);
	virtual TSelArea __fastcall GetSelArea(void);
	virtual void __fastcall DrawPasswordChar(const Vg_scene::TvgRect &SymbolRect, bool Selected);
	virtual void __fastcall CreatePopupMenu(void);
	virtual void __fastcall UpdatePopupMenuItems(void);
	virtual void __fastcall ApplyStyle(void);
	Vg_scene::TvgPoint __fastcall ContentPos(void);
	virtual void __fastcall Change(void);
	void __fastcall DoContentPaint(System::TObject* Sender, const Vg_scene::TvgCanvas* Canvas, const Vg_scene::TvgRect &ARect);
	virtual bool __fastcall ValidText(System::WideString NewText);
	bool __fastcall CanAutoSize(int &NewWidth, int &NewHeight);
	virtual void __fastcall ContextMenu(const Vg_scene::TvgPoint &ScreenPosition);
	virtual void __fastcall MouseWheel(Classes::TShiftState Shift, int WheelDelta, bool &Handled);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, float x, float y);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, float x, float y);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, float x, float y, float dx, float dy);
	virtual void __fastcall KeyDown(System::Word &Key, System::WideChar &KeyChar, Classes::TShiftState Shift);
	void __fastcall SelectWord(void);
	void __fastcall FontChanged(System::TObject* Sender);
	void __fastcall DoUndo(System::TObject* Sender);
	void __fastcall DoCut(System::TObject* Sender);
	void __fastcall DoCopy(System::TObject* Sender);
	void __fastcall DoPaste(System::TObject* Sender);
	void __fastcall DoDelete(System::TObject* Sender);
	void __fastcall DoSelectAll(System::TObject* Sender);
	void __fastcall UpdateLines(void);
	virtual System::Variant __fastcall GetData(void);
	virtual void __fastcall SetData(const System::Variant &Value);
	virtual void __fastcall EnterFocus(void);
	virtual void __fastcall KillFocus(void);
	HIDESBASE void __fastcall VScrollChange(System::TObject* Sender);
	virtual Vg_scene::TvgRect __fastcall GetContentBounds(void);
	
public:
	__fastcall virtual TvgMemo(Classes::TComponent* AOwner);
	__fastcall virtual ~TvgMemo(void);
	void __fastcall CopyToClipboard(void);
	void __fastcall PasteFromClipboard(void);
	void __fastcall CutToClipboard(void);
	void __fastcall ClearSelection(void);
	void __fastcall SelectAll(void);
	void __fastcall GoToTextEnd(void);
	void __fastcall GoToTextBegin(void);
	void __fastcall GotoLineEnd(void);
	void __fastcall GoToLineBegin(void);
	Vg_scene::TvgPoint __fastcall GetPositionPoint(const TCaretPosition &ACaretPos);
	void __fastcall UnDo(void);
	void __fastcall InsertAfter(const TCaretPosition &Position, System::WideString S, TInsertOptions Options);
	void __fastcall DeleteFrom(const TCaretPosition &Position, int ALength, TDeleteOptions Options);
	TCaretPosition __fastcall TextPosToPos(int APos);
	int __fastcall PosToTextPos(const TCaretPosition &APostion);
	__property int SelStart = {read=GetSelStart, write=SetSelStart, nodefault};
	__property int SelLength = {read=GetSelLength, write=SetSelLength, nodefault};
	__property System::WideString SelText = {read=GetSelText};
	__property TCaretPosition CaretPosition = {read=FCaretPosition, write=SetCaretPosition};
	__property float LineWidth[int LineNum] = {read=GetLineWidth};
	__property Vg_scene::TvgWideStrings* UnwrapLines = {read=GetUnwrapLines};
	__property Vg_scene::TvgBrush* FontFill = {read=FFontFill};
	__property Vg_scene::TvgBrush* SelectionFill = {read=FSelectionFill};
	
__published:
	__property Cursor = {default=-4};
	__property CanFocused = {default=1};
	__property DisableFocusEffect = {default=0};
	__property TabOrder = {default=-1};
	__property bool AutoSelect = {read=FAutoSelect, write=SetAutoSelect, default=1};
	__property TEditCharCase CharCase = {read=FCharCase, write=SetCharCase, default=0};
	__property Enabled = {default=1};
	__property bool HideSelection = {read=FHideSelection, write=SetHideSelection, default=1};
	__property Vg_scene::TvgWideStrings* Lines = {read=FLines, write=SetLines, stored=false};
	__property int MaxLength = {read=FMaxLength, write=SetMaxLength, default=0};
	__property bool ReadOnly = {read=FReadOnly, write=FReadOnly, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnChangeTracking = {read=FOnChangeTracking, write=FOnChangeTracking};
	__property bool WordWrap = {read=FWordWrap, write=SetWordWrap, nodefault};
	__property Vg_scene::TvgFont* Font = {read=FFont, write=SetFont};
	__property System::WideString Text = {read=FText, write=SetText, stored=true};
	__property Vg_scene::TvgTextAlign TextAlign = {read=FTextAlign, write=SetTextAlign, default=1};
	__property Resource;
};


class DELPHICLASS TvgHudMemo;
class PASCALIMPLEMENTATION TvgHudMemo : public TvgMemo
{
	typedef TvgMemo inherited;
	
public:
	/* TvgMemo.Create */ inline __fastcall virtual TvgHudMemo(Classes::TComponent* AOwner) : TvgMemo(AOwner) { }
	/* TvgMemo.Destroy */ inline __fastcall virtual ~TvgHudMemo(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TCaretPosition __fastcall ComposeCaretPos(int ALine, int APos);

}	/* namespace Vg_memo */
using namespace Vg_memo;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Vg_memoHPP
